/*
 *	misc.c
 *
 *	* Mon Dec 17 22:50:00 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

#define PATTERN_COLS	16

/****************************************************************************
 *	XvCg
 ****************************************************************************/

/* XvCg܂B
 * [in]
 *	spr		ŏ̃XvCgԍ
 *	count		XvCg
 * [out]
 *	߂l		̃XvCgԍ
 */
int
sprite_clear(int spr, int count)
{
	while(count != 0) {
		pclSpriteSetCharacter(spr, -8, -8, 0);
		spr++;
		count--;
	}

	return spr;
}

/* XvCgSď܂B
 */
void
sprite_clear_all()
{
	sprite_clear(0, N_SPRITES);
}

/* XvCgŕ`܂B
 * [in]
 *	spr		ŏ̃XvCgԍ
 *	x,y		̍W[sNZ]
 *	str		
 * [out]
 *	߂l		̃XvCgԍ
 */
int
sprite_print(int spr, int x, int y, const char* str)
{
	int x_cur, y_cur, chr;

	x_cur = x;
	y_cur = y;
	while((chr = *str++ & 255) != 0) {
		switch(chr) {
		case '\n':
			x_cur  = x;
			y_cur += 8;
			break;
		case '' & 255:
		case '' & 255:
			pclSpriteSetCharacter(spr, x_cur - 8, y_cur - 8, chr);
			spr++;
			break;
		default:
			pclSpriteSetCharacter(spr, x_cur, y_cur, chr);
			spr++;
			x_cur += 8;
			break;
		}
	}

	return spr;
}

/* XvCgŏt`܂B
 * [in]
 *	spr		ŏ̃XvCgԍ
 *	x,y		̍W[sNZ]
 *	fmt		
 *	...		ψ
 * [out]
 *	߂l		̃XvCgԍ
 */
int
sprite_printf(int spr, int x, int y, const char* fmt, ...)
{
	char buf[128]; /* 128𒴂Ȃ悤! */
	va_list ap;

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	va_end(ap);

	return sprite_print(spr, x, y, buf);
}

/* XvCgubN]܂B
 * [in]
 *	spr		ŏ̃XvCgԍ
 *	x,y		̍W[sNZ]
 *	chr		ŏ̃Lԍ
 *	cols,rows	LAcL
 * [out]
 *	߂l		̃XvCgԍ
 */
int
sprite_block(int spr, int x, int y, int chr, int cols, int rows)
{
	int x_cur, y_cur, col, row;

	for(row = 0, y_cur = y; row < rows; row++, y_cur += 8) {
		for(col = 0, x_cur = x; col < cols; col++, x_cur += 8) {
			pclSpriteSetCharacter(spr, x_cur, y_cur, chr);
			spr++;
			chr++;
		}
		chr += PATTERN_COLS - cols;
	}

	return spr;
}

/****************************************************************************
 *	af
 ****************************************************************************/

/* BG܂B
 * [in]
 *	bg		BGԍ
 */
void
bg_clear(int bg)
{
	int x, y;

	for(y = 0; y < 32; y++) {
		for(x = 0; x < 32; x++) {
			pclSpriteBGSetCharacter(bg, x, y, 0);
		}
	}
}

/* BGSď܂B
 */
void
bg_clear_all()
{
	bg_clear(0);
	bg_clear(1);
}

/* BGŕ`܂B
 * [in]
 *	bg		BGԍ
 *	x,y		̍W[L]
 *	str		
 */
void
bg_print(int bg, int x, int y, const char* str)
{
	int x_cur, y_cur, chr;

	x_cur = x;
	y_cur = y;
	while((chr = *str++ & 255) != 0) {
		switch(chr) {
		case '\n':
			x_cur = x;
			y_cur++;
			break;
		case '' & 255:
		case '' & 255:
			pclSpriteBGSetCharacter(bg, (x_cur - 1) & 31, (y_cur - 1) & 31, chr);
			break;
		default:
			pclSpriteBGSetCharacter(bg, x_cur & 31, y_cur & 31, chr);
			x_cur++;
			break;
		}
	}
}

/* BGŏt`܂B
 * [in]
 *	bg		BGԍ
 *	x,y		̍W[L]
 *	fmt		
 *	...		ψ
 */
void
bg_printf(int bg, int x, int y, const char* fmt, ...)
{
	char buf[128]; /* 128𒴂Ȃ悤! */
	va_list ap;

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	va_end(ap);
	bg_print(bg, x, y, buf);
}

/* BGubN]܂B
 * [in]
 *	bg		BGԍ
 *	x,y		̍W[L]
 *	chr		ŏ̃Lԍ
 *	cols,rows	LAcL
 */
void
bg_block(int bg, int x, int y, int chr, int cols, int rows)
{
	int x_cur, y_cur, col, row;

	for(row = 0, y_cur = y; row < rows; row++, y_cur++) {
		for(col = 0, x_cur = x; col < cols; col++, x_cur++) {
			pclSpriteBGSetCharacter(bg, x_cur & 31, y_cur & 31, chr);
			chr++;
		}
		chr += PATTERN_COLS - cols;
	}
}

/* BGɃp^[`܂B
 * [in]
 *	bg		BGԍ
 *	x,y		̍W[L]
 *	chr		Lԍ
 *	dot		hbgLԍ
 */
void
bg_pattern(int bg, int x, int y, int chr, int dot)
{
	int x_cur, y_cur, col, row;
	const unsigned char *pat;
	      unsigned char mask;

	/* 1L8CA1C3oCgAeC+2:}XNgpB */
	pat = PATTERN + 3 * 8 * chr + 2;

	for(row = 0, y_cur = y; row < 8; row++, y_cur++) {
		mask = *pat;
		for(col = 0, x_cur = x; col < 8; col++, x_cur++) {
			if(!(mask & 1)) { /* 1kLIv */
				pclSpriteBGSetCharacter(bg, x_cur & 31, y_cur & 31, dot);
			}
			mask >>= 1;
		}
		pat += 3;
	}
}

/****************************************************************************
 *	TEh
 ****************************************************************************/

static PCEWAVEINFO winfo[4];

/* TEh̏s܂B
 */
void
sound_init()
{
	int i;

	/* e`l̃{[őɖ߂܂B
	 * (ÕAvP[V̐ݒ肪cĂ܂悤Ȃ̂)
	 */
	for(i = 0; i < 3; i++) pceWaveSetChAtt(i, 0);
}

/* TEhĐ܂B
 * [in]
 *	ch	`l
 *	data	ADPCMf[^(pPCMcnv.EXEo͌`)
 */
void
sound_start(int ch, const void* data)
{
	winfo[ch] = *(PCEWAVEINFO*)((char*)data + 8);
	winfo[ch].pData = (char*)data + 8 + sizeof(PCEWAVEINFO);
	pceWaveDataOut(ch, &winfo[ch]);
}

/* TEh~܂B
 * [in]
 *	ch	`l
 */
void
sound_stop(int ch)
{
	pceWaveStop(ch);
}
